/**
 * Using our own exceptions - the same as using existing Java exceptions.
 */
public class Three
{
    /**
     * @throws MyFirstCheckedException              if I am in a bad mood
     * @throws MyImprovedIndexOutOfBoundsException  everytime IndexOutOfBounds is thrown
     */
    public void method1(boolean goodMood) throws MyFirstCheckedException, MyImprovedIndexOutOfBoundsException {
        if (! goodMood) {
            throw new MyFirstCheckedException("bad mood");
        }
        
        
        String[] array = new String[] {"abc", "def"};
        try {
            System.out.println(array[2]);
        } catch (ArrayIndexOutOfBoundsException e) {
            throw new MyImprovedIndexOutOfBoundsException(0, 1, 2, e); //idealne parametrizovat, nie natvrdo :)
        }
        
        
        String string = "abcde";
        int index = 5;
        try {
            System.out.println(string.charAt(index));
        } catch (StringIndexOutOfBoundsException e) {
            if (string.isEmpty()) {
                throw new MyImprovedIndexOutOfBoundsException(-1, -1, index);
            } else {
                throw new MyImprovedIndexOutOfBoundsException(0, string.length() - 1, index);
            }
        }
    }
    
    
    
    
    public void method2() throws MyFirstCheckedException {
        try {
            method1(false);
        } catch (MyImprovedIndexOutOfBoundsException e) {
            System.err.println("Vynimka: zly index (min. index: " + e.getLowerBound() + ", max. index: " + 
                               e.getUpperBound() + ", zly index: " + e.getWrongIndex());
            return;
        } finally {
            System.out.println("A vliezlo to este aj do finally");
        }
    }
}
